package BankApp;


//the packet is using the longest possible fields
public class Packet
{
	//CONSTANT FOR OPTYPE
	public static final int OPEN=0;
	public static final int DEPOSIT=1;
	public static final int WITHDRAW=2;
	public static final int BALANCE=3;
	public static final int TRANSFER=4;

	//CONSTANT FOR OP_STATUS
	public static final int START=0;
	public static final int SUCCESS=1;
	public static final int FAILED=2;
	//replay only happens when backup becomes primary and try to replay message to finish unfinished transfer
	public static final int REPLAY=3;
	public static final int TEST=101;		// It's a test packet
	public static final int TEST_REPLY=102;		// It's a test reply packet
	public static final int RELOAD=103;		// It's a packet which request the monitor to relaunch a server

	public String opID;
	public long seqNumber=0; //this is used in socket communication
	public int opType=0;
	public int source=0;
	public int dest=0;
	public float oldValue=0;
	public float newValue=0;
	public float destOldValue=0;
	public float destNewValue=0;
	public int tag=0;//maybe used as return address port number in socket communication
	public int status=0;

	public void display()
	{
		System.out.print("opID="+opID+", ");
		System.out.print("seqNumber="+seqNumber+", ");
		System.out.print("opType="+opType+", ");
		System.out.print("source="+source+", ");
		System.out.print("dest="+dest+", ");
		System.out.print("oldValue="+oldValue+", ");
		System.out.print("newValue="+newValue+", ");
		System.out.print("destOldValue="+destOldValue+", ");
		System.out.print("destNewValue="+destNewValue+", ");
		System.out.print("tag="+tag+", ");
		System.out.println("status="+status+"\n");
	}

};
